# class KComboBox | An enhanced combo box. More...
Definition | `#include <kcombobox.h>`
Inherits | KCompletionBase (kdecore) [public ], QComboBox (qt) [public ]
Inherited by | KHistoryCombo
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Methods

- KComboBox ( QWidget *parent=0, const char *name=0 )
- KComboBox ( bool rw, QWidget *parent=0, const char *name=0 )
- virtual ~KComboBox ()
- void setEditURL ( const KURL& url )
- void insertURL ( const KURL& url, int index = -1 )
- void insertURL ( const QPixmap& pixmap, const KURL& url, int index = -1 )
- void changeURL ( const KURL& url, int index )
- void changeURL ( const QPixmap& pixmap, const KURL& url, int index )
- int cursorPosition () const
- virtual void setAutoCompletion ( bool autocomplete )
- bool autoCompletion () const
- virtual void setContextMenuEnabled ( bool showMenu )
- bool isContextMenuEnabled () const
- void setURLDropsEnabled ( bool enable )
- bool isURLDropsEnabled () const
- bool isEditable () const
- bool contains ( const QString& text ) const
- void setTrapReturnKey ( bool trap )
- bool trapReturnKey () const
- virtual void setCompletionMode ( KGlobalSettings::Completion mode )
- KCompletionBox * completionBox ()

#### Public Slots

- void rotateText ( KCompletionBase::KeyBindingType )
- virtual void setCompletedText ( const QString& )
- void setCompletedItems ( const QStringList& items )

#### Signals

- void returnPressed ()
- void returnPressed ( const QString& )
- void completion ( const QString& )
- void textRotation ( KCompletionBase::KeyBindingType )
- void completionModeChanged ( KGlobalSettings::Completion )

#### Protected Methods

- virtual void setCompletedText ( const QString& , bool )

#### Protected Slots

- virtual void itemSelected ( QListBoxItem* )
- virtual void makeCompletion ( const QString& )
- void slotAboutToShow ()
- void slotCancelled ()

## Detailed Description

A combined button, line-edit and a popup list widget.

### Detail

This widget inherits from QComboBox and implements the following additional functionalities: a completion object that provides both automatic and manual text completion as well as text rotation features, configurable key-bindings to activate these features, and a popup-menu item that can be used to allow the user to set text completion modes on the fly based on their preference.

To support these new features KComboBox also emits a few more additional signals as well. The main ones are the completion( const QString& ) and textRotation( KeyBindgingType ) signals. The completion signal is intended to be connected to a slot that will assist the user in filling out the remaining text while the rotation signals is intended to be used to trasverse through all possible matches whenever text completion results in multiple matches. The returnPressed() and returnPressed( const QString& ) signal is emitted when the user presses the Enter/Return key.

This widget by default creates a completion object when you invoke the completionObject( bool ) member function for the first time or use setCompletionObject( KCompletion*, bool ) to assign your own completion object. Additionally, to make this widget more functional, KComboBox will by default handle the text rotation and completion events internally whenever a completion object is created through either one of the methods mentioned above. If you do not need this functionality, simply use KCompletionBase::setHandleSignals( bool ) or alternatively set the boolean parameter in the above methods to FALSE.

The default key-bindings for completion and rotation is determined from the global settings in KStdAccel. These values, however, can be overriden locally by invoking KCompletionBase::setKeyBinding(). The values can easily be reverted back to the default setting, by simply calling useGlobalSettings(). An alternate method would be to default individual key-bindings by usning setKeyBinding() with the default second argument.

Note that if this widget is not editable ( i.e. select-only ), then only one completion mode, `CompletionAuto`, will work. All the other modes are simply ignored. The `CompletionAuto` mode in this case allows you to automatically select an item from the list by trying to match the pressed keycode with the first letter of the enteries in the combo box.

### Example

To enable the basic completion feature:

     KComboBox *combo = new KComboBox( true, this, "mywidget" );
     KCompletion *comp = combo->completionObject();
     // Connect to the return pressed signal - optional
     connect(combo,SIGNAL(returnPressed(const QString&)),comp,SLOT(addItem(const QString&));

To use your own completion object:

     KComboBox *combo = new KComboBox( this,"mywidget" );
     KURLCompletion *comp = new KURLCompletion();
     combo->setCompletionObject( comp );
     // Connect to the return pressed signal - optional
     connect(combo,SIGNAL(returnPressed(const QString&)),comp,SLOT(addItem(const QString&));

Note that you have to either delete the allocated completion object when you don't need it anymore, or call setAutoDeleteCompletionObject( true );

Miscellaneous function calls:

     // Tell the widget not to handle completion and rotation
     combo->setHandleSignals( false );
     // Set your own completion key for manual completions.
     combo->setKeyBinding( KCompletionBase::TextCompletion, Qt::End );
     // Hide the context (popup) menu
     combo->setContextMenuEnabled( false );
     // Temporarly disable signal emition
     combo->disableSignals();
     // Default the all key-bindings to their system-wide settings.
     combo->useGlobalKeyBindings();

KComboBox ( QWidget *parent=0, const char *name=0 ) | ### KComboBox

Construct a read-only or rather select-only combo box with a parent object and a name.

Parameters:

parent | The parent object of this widget
name | The name of this widget

KComboBox ( bool rw, QWidget *parent=0, const char *name=0 ) | ### KComboBox

Construct a "read-write" or "read-only" combo box depending on the value of the first argument( `rw` ) with a parent, a name.

Parameters:

rw | When `true`, widget will be editable.
parent | The parent object of this widget.
name | The name of this widget.

~KComboBox () | ### ~KComboBox

[virtual]

Destructor.

void setEditURL ( const KURL& url ) | ### setEditURL

Sets `url` into the edit field of the combobox. It uses KURL::prettyURL() so that the url is properly decoded for displaying.

void insertURL ( const KURL& url, int index = -1 ) | ### insertURL

Inserts `url` at position `index` into the combobox. The item will be appended if `index` is negative. KURL::prettyURL() is used so that the url is properly decoded for displaying.

void insertURL ( const QPixmap& pixmap, const KURL& url, int index = -1 ) | ### insertURL

Inserts `url` with the pixmap &p pixmap at position `index` into the combobox. The item will be appended if `index` is negative. KURL::prettyURL() is used so that the url is properly decoded for displaying.

void changeURL ( const KURL& url, int index ) | ### changeURL

Replaces the item at position `index` with `url`. KURL::prettyURL() is used so that the url is properly decoded for displaying.

void changeURL ( const QPixmap& pixmap, const KURL& url, int index ) | ### changeURL

Replaces the item at position `index` with `url` and pixmap `pixmap`. KURL::prettyURL() is used so that the url is properly decoded for displaying.

int cursorPosition () | ### cursorPosition

[const]

Retreive the current cursor position.

This method always returns a -1 if the combo-box is not editable (read-write).

Returns: Current cursor position.

void setAutoCompletion ( bool autocomplete ) | ### setAutoCompletion

[virtual]

Re-implemented from QComboBox.

If `true`, the completion mode will be set to automatic. Otherwise, it is defaulted to the gloabl setting. This methods has been replaced by the more comprehensive setCompletionMode().

Parameters:

autocomplete | Flag to enable/disable automatic completion mode.

Reimplemented from QComboBox.

bool autoCompletion () | ### autoCompletion

[const]

Re-implemented from QComboBox.

Returns `true` if the current completion mode is set to automatic. See its more comprehensive replacement completionMode().

Returns: `true` when completion mode is automatic.

Reimplemented from QComboBox.

void setContextMenuEnabled ( bool showMenu ) | ### setContextMenuEnabled

[virtual]

Enable or disable the popup (context) menu.

This method only works if this widget is editable, i.e. read-write and allows you to enable/disable the context menu. It does nothing if invoked for a none-editable combo-box. Note that by default the mode changer item is made visiable whenever the context menu is enabled. Use hideModechanger() if you want to hide this item. Also by default, the context menu is created if this widget is editable. Call this function with the argument set to false to disable the popup menu.

Parameters:

showMenu | If `true`, show the context menu.
showMode | If `true`, show the mode changer.

bool isContextMenuEnabled () | ### isContextMenuEnabled

[const]

Returns `true` when the context menu is enabled.

Returns: `true` if context menu is enabled.

void setURLDropsEnabled ( bool enable ) | ### setURLDropsEnabled

Enables/Disables handling of URL drops. If enabled and the user drops an URL, the decoded URL will be inserted. Otherwise the default behaviour of QComboBox is used, which inserts the encoded URL.

Parameters:

enable | If `true`, insert decoded URLs

bool isURLDropsEnabled () | ### isURLDropsEnabled

[const]

Returns `true` when decoded URL drops are enabled

Returns: `true` if decoded URL drops are enabled

bool isEditable () | ### isEditable

[const]

Returns `true` if the combo-box is editable.

Returns: `true` if combo is editable.

bool contains ( const QString& text ) | ### contains

[const]

Convenience method which iterates over all items and checks if any of them is equal to `text`.

If `text` is an empty string, `false` is returned.

Returns: `true` if an item with the string `text` is in the combobox.

void setTrapReturnKey ( bool trap ) | ### setTrapReturnKey

By default, KComboBox recognizes Key_Return and Key_Enter and emits the returnPressed() signals, but it also lets the event pass, for example causing a dialog's default-button to be called.

Call this method with `trap` equal to `true` to make KComboBox stop these events. The signals will still be emitted of course.

Only affects read-writable comboboxes.

See also: setTrapReturnKey()

bool trapReturnKey () | ### trapReturnKey

[const]

Returns: `true` if keyevents of Key_Return or Key_Enter will be stopped or if they will be propagated.

See also: setTrapReturnKey, ()

bool eventFilter ( QObject *, QEvent * ) | ### eventFilter

[virtual]

Re-implemented for internal reasons. API not affected.

Reimplemented from QComboBox for internal purposes..

void setCompletionMode ( KGlobalSettings::Completion mode ) | ### setCompletionMode

[virtual]

Re-implemented from KCompletionBase for internal reasons.

Reimplemented from KCompletionBase.

KCompletionBox * completionBox () | ### completionBox

Returns: the completion-box, that is used in completion mode KGlobalSettings::CompletionPopup. This method will create a completion-box by calling makeCompletionBox, if none is there, yet.

void returnPressed () | ### returnPressed

[signal]

Emitted when the user presses the Enter key.

Note that this signal is only emitted if this widget is editable.

void returnPressed ( const QString& ) | ### returnPressed

[signal]

Emitted when the user presses the Enter key.

The argument is the current text being edited. This signal is just like returnPressed() except it contains the current text as its argument.

Note that this signal is only emitted if this widget is editable.

void completion ( const QString& ) | ### completion

[signal]

This signal is emitted when the completion key is pressed.

The argument is the current text being edited.

Note that this signal is not available if this widget is non-editable or the completion mode is set to `KGlobalSettings::CompletionNone`.

void textRotation ( KCompletionBase::KeyBindingType ) | ### textRotation

[signal]

Emitted when the text rotation key-bindings are pressed.

The argument indicates which key-binding was pressed. In this case this can be either one of four values: `PrevCompletionMatch`, `NextCompletionMatch`, `RotateUp` or `RotateDown`. See KCompletionBase::setKeyBinding() for details.

Note that this signal is NOT emitted if the completion mode is set to CompletionNone.

void completionModeChanged ( KGlobalSettings::Completion ) | ### completionModeChanged

[signal]

Emitted when the user changed the completion mode by using the popupmenu.

void rotateText ( KCompletionBase::KeyBindingType ) | ### rotateText

[slot]

Iterate through all possible matches of the completed text or the history list.

Depending on the value of the argument, this function either iterates through the history list of this widget or the all possible matches in whenever multiple matches result from a text completion request. Note that the all-possible-match iteration will not work if there are no previous matches, i.e. no text has been completed and the *nix shell history list rotation is only available if the insertion policy for this widget is set either `QComobBox::AtTop` or `QComboBox::AtBottom`. For other insertion modes whatever has been typed by the user when the rotation event was initiated will be lost.

Parameters:

type | The key-binding invoked.

void setCompletedText ( const QString& ) | ### setCompletedText

[virtual slot]

Sets the completed text in the line-edit appropriately.

This function is an implementation for KCompletionBase::setCompletedText.

Reimplemented from KCompletionBase.

void setCompletedItems ( const QStringList& items ) | ### setCompletedItems

[slot]

Sets `items` into the completion-box if completionMode() is CompletionPopup. The popup will be shown immediately.

void itemSelected ( QListBoxItem* ) | ### itemSelected

[protected slots virtual slot]

void makeCompletion ( const QString& ) | ### makeCompletion

[protected slots virtual slot]

Completes text according to the completion mode.

Note: this method is `not` invoked if the completion mode is set to CompletionNone. Also if the mode is set to `CompletionShell` and multiple matches are found, this method will complete the text to the first match with a beep to inidicate that there are more matches. Then any successive completion key event iterates through the remaining matches. This way the rotation functionality is left to iterate through the list as usual.

void slotAboutToShow () | ### slotAboutToShow

[protected slots slot]

Stores the current text whenever the completion box is displayed for the first time.

void slotCancelled () | ### slotCancelled

[protected slots slot]

Re-stores the current text if the completion box is cancelled by the user.

void keyPressEvent ( QKeyEvent* ) | ### keyPressEvent

[protected virtual]

Reimplemented from QComboBox for internal purposes..

void setCompletedText ( const QString& , bool ) | ### setCompletedText

[protected virtual]

Reimplemented from KCompletionBase.

- Author: Dawit Alemayehu <adawit@kde.org>
- Generated: root@i386.ports.openbsd.org on Wed Apr 25 13:58:24 2001, using kdoc 2.0a53.